/*******************************************************************************
 * Copyright (c) 2008 The University of York.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Dimitrios Kolovos - initial API and implementation
 *      H�ctor Iturria S�nchez - posProccess() now is boolean
 ******************************************************************************/
package es.cv.gvcase.linkers.test.evl;

import java.io.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.epsilon.eol.IEolExecutableModule;
import org.eclipse.epsilon.eol.models.IModel;
import org.eclipse.epsilon.evl.EvlModule;
import org.eclipse.epsilon.evl.EvlUnsatisfiedConstraint;

import es.cv.gvcase.linkers.test.junit.OutputLog;

public class EvlStandaloneFile extends EpsilonStandaloneFile {
	
	@Override
	public IEolExecutableModule createModule() {
		return new EvlModule();
	}

	@Override
	public List<IModel> getModels(String modelFile, String metamodelFile, String metamodelUri, String dirModels) throws Exception {
		List<IModel> models = new ArrayList<IModel>();
		models.add(createEmfModel("Model", modelFile , metamodelFile, true, true));
		return models;
	}
	
	@Override
	public boolean postProcess(String fileName, PrintWriter output) {
		
		EvlModule module = (EvlModule) this.module;
		
		Collection<EvlUnsatisfiedConstraint> unsatisfied = module.getContext().getUnsatisfiedConstraints();
	
		if (unsatisfied.size() > 0) {
			System.err.println(unsatisfied.size() + " constraint(s) have not been satisfied");
			OutputLog.addToLog("\nIn validation " + fileName , output);
			OutputLog.addToLog(unsatisfied.size() + " constraint(s) have not been satisfied", output);
			for (EvlUnsatisfiedConstraint uc : unsatisfied) {
				System.err.println(uc.getMessage());
				OutputLog.addToLog(uc.getMessage(), output);
				
			}
			//returns true if there are errors
			return true;
		}
		else {
			System.out.println("All constraints have been satisfied");
			//returns false if there are no errors
			return false;
		}
	}
	public boolean postProcess() {return true;}
	
}
