/***************************************************************************
* Copyright (c) 2007 Conselleria de Infraestructuras y Transporte,
* Generalitat de la Comunitat Valenciana . All rights reserved. This program
* and the accompanying materials are made available under the terms of the
* Eclipse Public License v1.0 which accompanies this distribution, and is
* available at http://www.eclipse.org/legal/epl-v10.html
*
* Contributors: Hctor Iturria Snchez - Initial API and implementation
*
******************************************************************************/

package es.cv.gvcase.linkers.test.junit;

import java.io.*;

import es.cv.gvcase.linkers.test.evl.*;

public class Validate {
	
	String dirModels;
	String dirValidations;
	String metamodelFile;
	String metamodelUri;
	String extension;
	
	EvlStandaloneMetamodelByUriFile evl;
	
	
	public Validate(String dModels, String dValidations, String mmFile, String mmUri, String ext){
	
		this.dirModels = dModels;
		this.dirValidations = dValidations;
		this.metamodelFile = mmFile;
		this.metamodelUri = mmUri;
		this.extension = ext;
		
		this.evl = new EvlStandaloneMetamodelByUriFile();
		
	}	
	
		
	public boolean execute(String fileName, PrintWriter ol){

		boolean errors = true;
		System.out.println("\nValidating: " + fileName);
		try {
			errors = evl.execute(fileName + "." + extension, metamodelFile, metamodelUri, dirModels, dirValidations, fileName + ".evl", ol);
		} catch (Exception e) {
			e.printStackTrace();
		}
    	return errors;
	
	}
	
	
}