/*******************************************************************************
 * Copyright (c) 2008 The University of York.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Dimitrios Kolovos - initial API and implementation
 ******************************************************************************/
package org.eclipse.epsilon.eol.exceptions;

import java.util.List;

import org.eclipse.epsilon.commons.parse.problem.ParseProblem;

public class EolEvaluatorException extends RuntimeException {

	// Generated by Eclipse
	private static final long serialVersionUID = 4509407892432452084L;

	public EolEvaluatorException() {
		super();
	}

	public EolEvaluatorException(String message) {
		super(message);
	}
	
	public EolEvaluatorException(Throwable cause) {
		super(cause);
	}
	
	public EolEvaluatorException(String message, Throwable cause) {
		super(message, cause);
	}

	public EolEvaluatorException(List<ParseProblem> problems) {
		super(problems.toString());
	}
}
